import DrawingObjects.DrawingCar;
import DrawingObjects.DrawingObjectCar;
import Generics.*;

import javax.swing.*;
import java.util.*;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;
import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.text.spi.BreakIteratorProvider;
import java.util.Arrays;
import java.util.List;

public class CarCollectionFrame extends JFrame {
    private CarsGenericCollection<DrawingCar, DrawingObjectCar> _cars;

    public CarCollectionFrame() {
        this.setSize(800, 600);
        this.setTitle("Collection");
        this.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        this.setResizable(false);
        this.setLocationRelativeTo(null);

        CollectionPanel panel = new CollectionPanel();

        this.add(panel);
        this.setVisible(true);
    }

    public class CollectionPanel extends JPanel {
        private CarsGenericStorage _storage;
        /*private DefaultListModel<String> listBoxStorages = new DefaultListModel<String>();
        JList listBoxStoragesJList = new JList<>();*/

        TrashCollection<DrawingCar> _trash = new TrashCollection<>();
        private JList<String> listBoxStoragesJList;
        private DefaultListModel<String> listBoxStorages;
        static final int SCREEN_W = 800;
        static final int SCREEN_H = 600;
        CollectionPanel() {
            _storage = new CarsGenericStorage(SCREEN_W,
                    SCREEN_H);
            this.setLayout(null);
            this.setPreferredSize(new Dimension(SCREEN_W, SCREEN_H));

            JTextField textFieldRemove = new JTextField();
            textFieldRemove.setBounds(600, 200, 150, 30);
            this.add(textFieldRemove);

            JButton ButtonAddCar = new JButton("Добавить машину");
            ButtonAddCar.setBounds(600, 150, 150, 30);
            ButtonAddCar.addActionListener(new ActionListener() {
                @Override
                public void actionPerformed(ActionEvent e) {
                    if(listBoxStoragesJList.getSelectedIndex() == -1) {
                        return;
                    }
                    CarsGenericCollection<DrawingCar, DrawingObjectCar> _cars = _storage.Get(listBoxStoragesJList.getSelectedValue());
                    GameFrame form = new GameFrame();
                    if (form.getSelectedCar() != null) {
                        if (_cars.plus(_cars, form.SelectedCar)) {
                            JOptionPane.showMessageDialog(null, "Объект добавлен");

                        } else {
                            JOptionPane.showMessageDialog(null, "Не удалось добавить объект");

                        }
                    }
                    repaint();
                }
            });
            this.add(ButtonAddCar);

            JButton ButtonRemoveCar = new JButton("Удалить машину");
            ButtonRemoveCar.setBounds(600, 250, 150, 30);
            ButtonRemoveCar.addActionListener(new ActionListener() {
                @Override
                public void actionPerformed(ActionEvent e) {
                    if(listBoxStoragesJList.getSelectedIndex() == -1) {
                        return;
                    }
                    CarsGenericCollection<DrawingCar, DrawingObjectCar> _cars = _storage.Get(listBoxStoragesJList.getSelectedValue());
                    if (_cars == null) {
                        return;
                    }
                    String tmp = textFieldRemove.getText();
                    int num;

                    try {
                        num = Integer.parseInt(tmp);
                    } catch (Exception ex) {
                        JOptionPane.showMessageDialog(null, "Введите число", "Информация", JOptionPane.INFORMATION_MESSAGE);
                        return;
                    }

                    DrawingCar deletedCar = _cars.Get(num);
                    _trash.Add(deletedCar);
                    _cars.minus(_cars, num);

                    JOptionPane.showMessageDialog(null, "Объект удален", "Информация", JOptionPane.INFORMATION_MESSAGE);
                    repaint();

                }
            });
            this.add(ButtonRemoveCar);

            JButton ButtonRefresh = new JButton("Обновить");
            ButtonRefresh.setBounds(600, 300, 150, 30);
            ButtonRefresh.addActionListener(new ActionListener() {
                @Override
                public void actionPerformed(ActionEvent e) {
                    if(listBoxStoragesJList.getSelectedIndex() == -1) {
                        return;
                    }
                    _cars = _storage.Get(listBoxStoragesJList.getSelectedValue());

                    repaint();
                }
            });
            this.add(ButtonRefresh);

            JButton ButtonDelStorage = new JButton("Удалить набор");
            ButtonDelStorage.setBounds(600, 450, 170, 30);
            ButtonDelStorage.addActionListener(new ActionListener() {
                @Override
                public void actionPerformed(ActionEvent e) {
                    if(listBoxStoragesJList.getSelectedIndex() == -1) {
                        return;
                    }
                    _storage.DelSet(listBoxStoragesJList.getSelectedValue());
                    ReloadObjects();
                }
            });
            this.add(ButtonDelStorage);

            JButton ButtonTrash = new JButton("Удаленные объекты");
            ButtonTrash.setBounds(600, 500, 170, 30);
            ButtonTrash.addActionListener(new ActionListener() {
                @Override
                public void actionPerformed(ActionEvent e) {
                    if(_trash.GetSize() == 0)
                        return;
                    GameFrame form = new GameFrame(_trash.GetLast());
                    //form.ChangeCar(_trash.GetLast());
                    _trash.PopHead();
                }
            });
            this.add(ButtonTrash);

            JTextField textBoxStorageName = new JTextField();
            textBoxStorageName.setBounds(600, 10, 150, 30);
            this.add(textBoxStorageName);

            JButton ButtonAddObject = new JButton("Добавить набор");
            ButtonAddObject.setBounds(600, 40, 150, 30);
            ButtonAddObject.addActionListener(new ActionListener() {
                @Override
                public void actionPerformed(ActionEvent e) {
                    if (textBoxStorageName.getText().equals( "") || textBoxStorageName.getText().equals(null))
                    {
                        /*MessageBox.Show("Не все данные заполнены", "Ошибка",
                                MessageBoxButtons.OK, MessageBoxIcon.Error);*/
                        return;
                    }

                    _storage.AddSet(textBoxStorageName.getText());
                    ReloadObjects();
                    repaint();
                }});
            this.add(ButtonAddObject);

            listBoxStorages = new DefaultListModel<>();
            listBoxStoragesJList = new JList<>(listBoxStorages);
            listBoxStoragesJList.setBounds(600, 350, 150, 70);
            listBoxStoragesJList.addListSelectionListener(new ListSelectionListener() {
                @Override
                public void valueChanged(ListSelectionEvent evt) {
                    if (!evt.getValueIsAdjusting()) { // Игнорируем событие mouseDown
                        // Получаем выбранное значение
                        if(listBoxStoragesJList.getSelectedIndex() == -1) {
                            return;
                        }
                        _cars = _storage.Get(listBoxStoragesJList.getSelectedValue());

                        repaint();
                        
                    }
                }

            });
            this.add(listBoxStoragesJList);


            _cars = new CarsGenericCollection<DrawingCar, DrawingObjectCar>(SCREEN_W, SCREEN_H);


        }
        private void ReloadObjects()
        {
            int index = listBoxStoragesJList.getSelectedIndex();
            listBoxStorages.clear();
            List<String> keys = _storage.Keys();
            for(int i = 0; i < keys.size(); i++){
                listBoxStorages.addElement(keys.get(i));
            }
            if(listBoxStorages.size() > 0 && (index == -1 || index >= listBoxStorages.size()))
                listBoxStoragesJList.setSelectedIndex(0);
            else if(listBoxStorages.size() > 0)
                listBoxStoragesJList.setSelectedIndex(index);
        }

        @Override
        public void paintComponent(Graphics g) {
            super.paintComponent(g);
            draw(g);
        }

        public void draw(Graphics g) {
            if (listBoxStoragesJList.getSelectedIndex() != -1) {
                _storage.getByIndex(listBoxStorages.get(listBoxStoragesJList.getSelectedIndex())).ShowCars(g);
                _cars.ShowCars(g);
            }
        }
    }
}
