package Generics;

import DrawingObjects.*;

import java.util.*;
import java.util.stream.Collectors;

public class CarsGenericStorage {
    Map<String, CarsGenericCollection<DrawingCar, DrawingObjectCar>> _carStorages;
    public List<String> Keys;

    public List<String> Keys(){
        if(_carStorages == null)
            return null;
        return _carStorages.keySet().stream().collect(Collectors.toList());
    }
    private int _pictureWidth;
    private int _pictureHeight;
    public CarsGenericStorage(int pictureWidth, int pictureHeight)
    {
        _carStorages = new HashMap<String,
                CarsGenericCollection<DrawingCar, DrawingObjectCar>>();
        _pictureWidth = pictureWidth;
        _pictureHeight = pictureHeight;
    }
    public void AddSet(String name)
    {
        _carStorages.put(name, new CarsGenericCollection<DrawingCar, DrawingObjectCar>(_pictureWidth, _pictureHeight));
    }
    public void DelSet(String name)
    {
        if (!_carStorages.containsKey(name))
        {
            return;
        }
        _carStorages.remove(name);
    }
    public CarsGenericCollection<DrawingCar, DrawingObjectCar> getByIndex(String indexOfDict){
        if (_carStorages.containsKey(indexOfDict)){
            return _carStorages.get(indexOfDict);
        }
        return null;
    }

    public CarsGenericCollection<DrawingCar, DrawingObjectCar> Get(String name){
        if(!_carStorages.containsKey(name))
            return null;
        return _carStorages.get(name);
    }
    public DrawingCar Get(String collectionName, int position){
        return _carStorages.get(collectionName).Get(position);
    }

}