import javax.swing.*;
import javax.swing.plaf.basic.BasicArrowButton;
import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.Arrays;
import java.util.Random;

import Dop.DopClassRect;
import Dop.DopClassTriangle;
import Dop.IDop;
import Dop.NumberOfWheels;
import Entities.*;
import DrawingObjects.*;
import Entities.EntityDumpTruck;
import Generics.GenericCreate;
import MovementStrategy.*;

public class RandomFrame extends JFrame {
    RandomPanel panel = new RandomPanel();
    RandomFrame() {
        this.setSize(710, 535);
        this.setTitle("DumpTruckRandom");
        this.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        this.setResizable(false);
        this.setLocationRelativeTo(null);


        this.add(panel);

        this.setVisible(true);
    }

    public class RandomPanel extends JPanel {
        static final int SCREEN_W = 700;
        static final int SCREEN_H = 500;
        GenericCreate<EntityCar, IDop> _genericCreate = new GenericCreate<>(10, 10);

        ComponentsPanel entitiesPanel = new ComponentsPanel();
        ComponentsPanel wheelsPanel = new ComponentsPanel();
        DrawingCar generatedCar;
        RandomPanel() {
            this.setLayout(null);
            this.setPreferredSize(new Dimension(SCREEN_W, SCREEN_H));



            JButton buttonCar = new JButton("Создать грузовик");
            buttonCar.setBounds(20, 20, 130, 30);
            buttonCar.addActionListener(new ActionListener() {
                @Override
                public void actionPerformed(ActionEvent e) {

                    GameFrame dialogWindow = new GameFrame();
                    if (dialogWindow.getSelectedCar() != null){
                        if (dialogWindow.getSelectedCar() instanceof DrawingDumpTruck) {
                            _genericCreate.Add(((DrawingDumpTruck) dialogWindow.getSelectedCar()).getEntityDumpTruck());
                        }
                        else {
                            _genericCreate.Add(dialogWindow.getSelectedCar().EntityCar);
                        }
                        repaint();}

                        else{
                        System.out.println("Selected car is null!");
                        }

                    }

                });
            this.add(buttonCar);

            JButton buttonIDop = new JButton("Создать колеса");
            buttonIDop.addActionListener(new ActionListener() {
                @Override
                public void actionPerformed(ActionEvent e) {
                    Random random = new Random();
                    IDop interWheels;
                    switch(random.nextInt(1, 4)){
                        case 1:
                            interWheels = new NumberOfWheels(random.nextInt(2, 5));
                            break;
                        case 2:
                            interWheels = new DopClassRect(random.nextInt(2, 5));
                            break;
                        default:
                            interWheels = new DopClassTriangle(random.nextInt(2, 5));
                            break;
                    }

                    _genericCreate.Add(interWheels);
                    repaint();

                }
            });
            buttonIDop.setBounds(20 + 130 + 20, 20, 130, 30);
            this.add(buttonIDop);

            JButton buttonCreateRandomCar = new JButton("Сгенерировать машину");
            buttonCreateRandomCar.addActionListener(new ActionListener() {
                @Override
                public void actionPerformed(ActionEvent e) {
                    generatedCar = _genericCreate.DrawingGeneratedCar();
                    if (generatedCar != null) {
                        generatedCar.SetPosition(430, 160);
                    }
                    repaint();

                }
            });
            buttonCreateRandomCar.setBounds(20 + 130 + 20 + 235, 20 + 80, 190, 30);
            this.add(buttonCreateRandomCar);


            /*entitiesPanel.setLocation(20, 20 + 50);
            this.add(entitiesPanel);*/

            /*wheelsPanel.setLocation(20 + 150, 20 + 50);
            this.add(wheelsPanel);*/

            /*CarRandomPanel carRandomPanel = new CarRandomPanel();
            carRandomPanel.setLocation(400, 150);
            this.add(carRandomPanel);*/

        }
        @Override
        public void paintComponent(Graphics g) {
            super.paintComponent(g);
            draw(g);
        }

        public void draw(Graphics g) {
            int startX = 20 ;
            int startY = 70;

            int startXForWheels = 170;
            int startYForWheels = 30;
            int height = 70;
            int width = 110;
            _genericCreate.DrawEntitiesCars(g, startX, startY);

            for (int i=0; i < _genericCreate.getWheels().size(); i++) {
                _genericCreate.getWheels().get(i).drawWheels(g, startXForWheels, startYForWheels + i * 30, Color.black);
            }

            if (generatedCar != null){
                generatedCar.DrawTransport(g);
            }
        }
    }

    public class ComponentsPanel extends JPanel {
        static final int SCREEN_W = 130;
        static final int SCREEN_H = 400;

        ComponentsPanel() {
            this.setSize(SCREEN_W, SCREEN_H);
            //this.setBackground(Color.WHITE);
        }
        @Override
        public void paintComponent(Graphics g) {
            super.paintComponent(g);

        }

        public void draw(Graphics g) {

        }
    }
    public class CarRandomPanel extends JPanel {
        static final int SCREEN_W = 200;
        static final int SCREEN_H = 200;

        CarRandomPanel() {
            this.setSize(SCREEN_W, SCREEN_H);
            this.setBackground(Color.LIGHT_GRAY);
        }
        @Override
        public void paintComponent(Graphics g) {
            super.paintComponent(g);
            draw(g);
        }

        public void draw(Graphics g) {

        }
    }
    }